package com.muyu.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author：chaiyapeng
 * @Package：com.muyu.domain
 * @Project：cloud-mart
 * @name：Connector
 * @Date：2024/8/26 10:03
 */
@Data
public class Connector {
    /**
     * id
     */
    private Long connectorId;
    /**
     * 接口名称
     */
    private String connectorName;
    /**
     * 接口分类
     */
    private String connectorSort;
    /**
     * 接口描述
     */
    private String connectorDescribe;
    /**
     * 接口图片
     */
    private String connectorPicture;
    /**
     * 公司
     */
    private String connectorCompany;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date connectorTime;
    /**
     * 价格
     */
    private BigDecimal connectorPrice;
    /**
     * API_URL
     */
    private String connectorApiurl;
    /**
     * API_EYE
     */
    private String connectorApikey;
    /**
     * 请求方式
     */
    private String connectorRequest;
    /**
     * 状态
     */
    private Integer connectorStatus;
}
