package com.muyu.cloud.mart.controller;

import cn.hutool.db.PageResult;
import com.dtflys.forest.annotation.Post;
import com.muyu.cloud.mart.service.ConnectorService;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.Connector;
import com.muyu.domain.ConnectorUser;
import com.muyu.domain.req.ConnectorUserReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * @Author：chaiyapeng
 * @Package：com.muyu.cloud.mart.controller
 * @Project：cloud-mart
 * @name：ConnectorController
 * @Date：2024/8/26 10:22
 */
@RestController
@RequestMapping("connector")
public class ConnectorController {
    @Autowired
    private ConnectorService connectorService;

    /**
     * 接口列表
     * @param connector
     * @return
     */
    @PostMapping("findConnectorList")
    public Result findConnectorList(@RequestBody Connector connector){
        return connectorService.findConnectorList(connector);
    }
    /**
     * API列表
     */
    @PostMapping("findApiList")
    public Result findApiList(@RequestBody Connector connector){
        return connectorService.findApiList(connector);
    }
    /**
     * 资产列表
     */
    @PostMapping("findConnectorUserList")
    public Result<List<ConnectorUser>> findConnectorUserList(@RequestBody ConnectorUserReq connectorUserReq){
        return connectorService.findConnectorUserList(connectorUserReq);
    }
    /**
     * 接口添加
     */
    @PostMapping("addConnector")
    public Result addConnector(@RequestBody Connector connector){
        return connectorService.addConnector(connector);
    }
    /**
     * 接口修改
     */
    @PostMapping("updateConnector")
    public Result updateConnector(@RequestBody Connector connector){
        return connectorService.updateConnector(connector);
    }
    /**
     * 接口删除
     */
    @GetMapping("getDeleteConnector")
    public Result getDeleteConnector(@RequestParam(name = "connectorId") Long connectorId){
        return connectorService.getDeleteConnector(connectorId);
    }

    /**
     * 上传图片
     */
//    @PostMapping("upload")
//    public Result upload(@RequestBody MultipartFile file){
//        return connectorService.upload(file);
//    }
}
