package com.muyu.cloud.mart.utils;

import com.muyu.domain.Birthday;

import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author：chaiyapeng
 * @Package：com.muyu.cloud.mart.utils
 * @Project：cloud-mart
 * @name：BirthdayHelper
 * @Date：2024/8/24 19:36
 * 生辰助手
 */
public class BirthdayHelper {

    public static StringBuffer queryBirthday(Birthday birthday){
        String apiKey = "9bbfc46233d4931c39207b090ed4b27c";
        String apiUrl = "http://apis.juhe.cn/birthEight/query";
        HashMap<String, String> map = new HashMap<>();

        map.put("key", apiKey);
        map.put("year", birthday.getYear());
        birthday.setYear(map.put("year", birthday.getYear()));
        map.put("month", birthday.getMonth());
        birthday.setMonth(map.put("month", birthday.getMonth()));
        map.put("day", birthday.getDay());
        birthday.setDay(map.put("day", birthday.getDay()));
        map.put("hour", birthday.getHour());
        birthday.setHour(map.put("hour", birthday.getHour()));
        try {
            URL url = new URL(String.format(apiUrl + "?" + params(map)));
            BufferedReader in = new BufferedReader(new InputStreamReader((url.openConnection()).getInputStream()));
            String inputLine;
            StringBuffer response = new StringBuffer();
            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine);
            }
            in.close();
            System.out.println(response);
            return response;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }


    public static String params(Map<String, String> map) {
        return map.entrySet().stream()
                .map(entry -> {
                    try {
                        return entry.getKey() + "=" + URLEncoder.encode(entry.getValue(), StandardCharsets.UTF_8.toString());
                    } catch (Exception e) {
                        e.printStackTrace();
                        return entry.getKey() + "=" + entry.getValue();
                    }
                })
                .collect(Collectors.joining("&"));
    }
}
