package com.muyu.cloud.mart.utils;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author：chaiyapeng
 * @Package：com.muyu.cloud.mart.utils
 * @Project：cloud-mart
 * @name：IPLocation
 * @Date：2024/8/23 20:54
 * IP查询归属地
 */
public class IPLocation {
    public static StringBuffer queryIPLocation(String ip){
        String apiKey = "e84b7d13a9fb87b4ebcc9813e4518955";
        String apiUrl = "http://apis.juhe.cn/ip/ipNewV3";
        HashMap<String, String> map = new HashMap<>();
        map.put("key", apiKey);
        map.put("ip", ip);
        try {
            URL url = new URL(String.format(apiUrl + "?" + params(map)));
            BufferedReader in = new BufferedReader(new InputStreamReader((url.openConnection()).getInputStream()));
            String inputLine;
            StringBuffer stringBuffer = new StringBuffer();
            while ((inputLine = in.readLine()) != null){
                stringBuffer.append(inputLine);
            }
            in.close();
            System.out.println(stringBuffer);
            return stringBuffer;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }


    public static String params(Map<String, String> map) {
        return map.entrySet().stream()
                .map(entry -> {
                    try {
                        return entry.getKey() + "=" + URLEncoder.encode(entry.getValue(), StandardCharsets.UTF_8.toString());
                    } catch (Exception e) {
                        e.printStackTrace();
                        return entry.getKey() + "=" + entry.getValue();
                    }
                })
                .collect(Collectors.joining("&"));
    }
}
