package com.muyu.cloud.mart.utils;

import com.muyu.domain.Postcode;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;
/**
 * @Author：chaiyapeng
 * @Package：com.muyu.cloud.mart.utils
 * @Project：cloud-mart
 * @name：Postcode
 * @Date：2024/8/24 20:50
 */
public class PostcodeInquire {

    public static StringBuffer queryPostcode(Postcode postcode){
        String apiKey = "0cabcd31c150369d8afb2c8b7e41a2c0";
        String apiUrl = "http://v.juhe.cn/postcode/query";

        HashMap<String, String> map = new HashMap<>();
        map.put("key", apiKey);
        map.put("postcode", postcode.getPostcode());//邮编，如：215001
        postcode.setPostcode(map.put("postcode", postcode.getPostcode()));
        map.put("page", String.valueOf(postcode.getPage()));//页数，默认1
        map.put("pagesize", "");//每页返回，默认:20,最大不超过50
        map.put("dtype", "json");//返回数据的格式,xml或json，默认json
        try {
            URL url = new URL(String.format(apiUrl + "?" + params(map)));
            BufferedReader in = new BufferedReader(new InputStreamReader((url.openConnection()).getInputStream()));
            String inputLine;
            StringBuffer response = new StringBuffer();
            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine);
            }
            in.close();
            System.out.println(response);
            return response;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public static String params(Map<String, String> map) {
        return map.entrySet().stream()
                .map(entry -> {
                    try {
                        return entry.getKey() + "=" + URLEncoder.encode(entry.getValue(), StandardCharsets.UTF_8.toString());
                    } catch (Exception e) {
                        e.printStackTrace();
                        return entry.getKey() + "=" + entry.getValue();
                    }
                })
                .collect(Collectors.joining("&"));
    }
}
